#include <dos.h>
#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

/* Include for DJGCC compiler*/
/*#include <pc.h> */

/*  CONSTANTS  */
#define bytesPerPixel      2
#define INFORM_PROG_NAME   "hitest"
#define PAGESIZE           (64L*1024L)

/*  GLOBALS  */
char dac;

void himode ()
{
  union REGS regs;

/* Check DAC type installed */
  regs.h.ah = 0x10;
  regs.h.al = 0xF1;
  int86(0x10, &regs, &regs);
  dac = regs.h.bl;

  regs.x.ax = 0x10f0;
/* 640x480 = 0x2E, 800x600 = 0x30 */
/*  regs.x.bx = 0x2E;*/
  regs.x.bx = 0x30;
  regs.x.cx = 0;
  regs.x.dx = 0;

  int86 (0x10, &regs, &regs);

  if (regs.h.ah != 0)
	{
		printf("HiColor mode not set\n");
		exit(1);
	}
}

void
Textmode ()
{
  union REGS regs;

  regs.x.ax = 0x03;
  regs.x.bx = 0x0;
  regs.x.cx = 0;
  regs.x.dx = 0;

  int86 (0x10, &regs, &regs);
}

void
Putpixel (x, y, r, g, b)
	  int x, y;
	  char r, g, b;
{
  union REGS regs;

/*  if (x < 640 && y < 480) */
  if (x < 800 && y < 600)
	 {
		regs.h.ah = 0x0c;
		regs.h.al = ((g & 7) << 5) + (b & 31);
		regs.x.bx = 0;
		regs.x.cx = 2 * x;
		regs.x.dx = y;

		int86 (0x10, &regs, &regs);

		regs.h.ah = 0x0c;
		regs.h.al = ((g & 24) >> 3) + ((r & 31) << 2);
		regs.x.bx = 0;
		regs.x.cx = 2 * x + 1;
		regs.x.dx = y;

		int86 (0x10, &regs, &regs);
	 }
}

main()
{
int  i, j;
char r, g, b;
int  d1, d2, d3;

himode();

for ( j=0; j<800; j+= 1 )
  for ( i=0; i<600; i+=1 )
	{
	d1 = (int)sqrt( (double)i*(double)i + (double)j*(double)j );
	d2 = (int)sqrt( (double)(j-800)*(double)(j-800) + (double)i*(double)i );
	d3 = (int)sqrt( (double)(i-600)*(double)(i-600) + (double)(j-400)*(double)(j-400) );

	r = ((d1/8)%32);
	g = ((d2/8)%32);
	b = ((d3/8)%32);
	Putpixel(j, i, r, g, b );
	}

printf("I'm finished.\n");
getch();
Textmode();
printf("Hello, World!\n");
printf("DAC type = %x\n",dac);
getch();
}

